# Comparability index computation
#
# Copyright (C) 2008-2011 Antonio García-Domínguez
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

package Comparability;

use strict;
use warnings;
use Exporter "import";
our @EXPORT_OK = qw(printComputedComparabilities splitTraces transformarDecls);

use Daikon qw(cargarDecls imprimirDecls loadActiveBPELLog
              rutaAsigAPunto pathToBasePP C_COMP C_TJAVA);
use FlattenDecls qw(C_DUMMYHASHCODE_COMP);
use Graph::Undirected;
use Storable qw(dclone store retrieve);
use Carp;

sub printComputedComparabilities {
  my ($disableFilterUnused, $arrayIndicesAreComparable, $rutaDecls, $saveGraphsTo, $rvLoadCGraphs, @rutasTrazas) = @_;

  my ($rhInfoTipos, $nombreProceso) = cargarDecls($rutaDecls);
  my $rhInfoComp                    = _loadCGraphs(@$rvLoadCGraphs);
  my $contador  = 1;
  my $numTrazas = scalar @rutasTrazas;
  foreach my $rutaTraza (@rutasTrazas) {
    print STDERR "Refining variable graphs from '$rutaTraza' ($contador/$numTrazas)...\n";

    my $rvContenido = loadActiveBPELLog($rutaTraza);
    my $rhTrazas = splitTraces($nombreProceso, $rhInfoTipos, $rvContenido);
    updateComparabilityGraphs($rhInfoTipos, $rhInfoComp, $rhTrazas, $nombreProceso);
    $contador++;
  }

  store($rhInfoComp, $saveGraphsTo);

  my $rhNuevasDecls = transformarDecls($rhInfoTipos, $rhInfoComp, $disableFilterUnused, $arrayIndicesAreComparable);
  imprimirDecls($rhNuevasDecls);
}

=head2 splitTraces(processName, rhVarsByPP, rvLogLines)

=over 2

=item Usage:

Public function.

=item Arguments:

=over 2

=item processName: name of the WS-BPEL process.

=item rhVarsByPP: reference to a hash from program point names to
references to hashes from the variables to their type information.

=item rvLogLines: reference to an array with the lines of the .log
file generated by ActiveBPEL.

=back

=item Description:

Returns a hash from the names of the program points to the lines of
interest that are related to them. Normally, a program point will have
all the lines of interest that were produced inside it.

=back

=cut

sub splitTraces
{
    my ($processName, $rhVarsByPP, $rvLogLines) = @_;

    my $fh = *STDOUT;

    # Map lines of interest to their immediate paths. Please note that
    # comparability scopes may be nested.
    my $rhTracesByPath = {};
    my $level = 0;
    my $dest = undef;
    foreach my $i (0..$#$rvLogLines)
    {
        my $line = $rvLogLines->[$i];

        if ($line =~ /inicio ambito/i) {
          if ($level == 0) {
            $i > 0 && $rvLogLines->[$i - 1] =~ /[^\[]*\[(.+)\]/
              or croak "Outermost scope start should be preceded by a line with the current execution path (line " . ($i + 1) . ")";

            $dest = $1;
          }

          $level++;
          _add_line($dest, $line, $rhTracesByPath);
        }
        elsif ($line =~ /fin ambito/i) {
          if ($level == 0) {
            croak "All scope endings should be preceded by a matching scope start (line $i)";
          }
          elsif ($level == 1) {
            if ($i < $#$rvLogLines && $rvLogLines->[$i + 1] =~ /completed normally assignment/i) {
              # Assignments right after the outermost scope ends should be moved to inside the scope
              _add_line($dest, $rvLogLines->[$i + 1], $rhTracesByPath);
            }
          }

          _add_line($dest, $line, $rhTracesByPath);
          $dest = undef unless --$level > 0;
        }
        elsif (defined $dest) {
          _add_line($dest, $line, $rhTracesByPath);
        }
    }

    # Map the lines of interest from paths to actual program points:
    #
    # 1. First, we search for the program point that contains this
    # path. If we can't find it, we use the current path as is.
    #
    # 2. Then, look for the program points contained in this path
    # (including the same path), and add the selected lines to it.
    #
    # Note: traces are ordered by key, to make the order of the
    # results easier to test.
    my $rhTracesByPP = {};
    foreach my $path (sort keys %$rhTracesByPath)
    {
      my $rvLines = $rhTracesByPath->{$path};
      my (undef, @pathParts) = split m#/#, $path;
      my $containerBasePP = pathToBasePP($processName, @pathParts);

      my $added = undef;
      foreach my $pp (keys %$rhVarsByPP) {
        my ($basePP, @dummy) = split /:::/, $pp;

        if (index($basePP, $containerBasePP) != 0 and index($containerBasePP, $basePP) != 0) {
          # We only want program points contained _inside_ this one,
          # or that contain this one. In a way, a variable used in a
          # program point propagates like a hourglass: its information
          # might be useful down there, but it also indicates that
          # there might be higher-level invariants resulting from
          # several smaller program points
          next;
        }
        $added = 1;

        foreach (@$rvLines)
          {
            _add_line($pp, $_, $rhTracesByPP);
          }
      }

      $added or warn "\"$path\" (program point '$containerBasePP') does not seem to be\n"
        . "contained in any of the existing program points, and it doesn't seem to contain any program points either:\n"
              . (join "\n", keys %$rhVarsByPP)
                . "\n"
                  ;
    }

    return $rhTracesByPP;
}

sub _add_line
{
    my ($dest, $line, $rhTraces) = @_;

    $rhTraces->{$dest} = [] unless defined $rhTraces->{$dest};
    push @{$rhTraces->{$dest}}, $line;
}

#
# Recibe las declaraciones originales y un hash sobre puntos de
# interés de objetos Graph::Undirected que recogen en la misma
# componente conexa las expresiones comparables, y modifica los
# identificadores de comparabilidad de las declaraciones de forma
# acorde.
#
sub transformarDecls
{
    my ($rhDecls, $rhInfoComp, $disableFilterUnused, $arrayIndicesAreComparable) = @_;

    my $rhNuevasDecls  = {};

    while (my ($punto, $rhPunto) = each(%$rhDecls)) {
        # We reserve C_DUMMYHASHCODE_COMP + 1 for the array subscript
        # comparability index when $arrayIndicesComparable is true
        my $contadorId = C_DUMMYHASHCODE_COMP() + 2;

        my $rhNewPP = {};
        my %hComparabilityIndices = ();
        my $comparabilityGraph = $rhInfoComp->{$punto};

        # Remove unused program points
        if (!defined($comparabilityGraph)) {
            next;
        }

        foreach my $expr (keys %$rhPunto) {
            my $graphComponent = $comparabilityGraph->connected_component_by_vertex($expr);
            my $comparabilityKey;
            if (!defined($graphComponent)) {
                unless ($disableFilterUnused) {
                    # Unused values are removed here
                    next;
                }
                else {
                    $comparabilityKey = $expr;
                }
            }
            else {
                # Use the first expression in the connected component as the key
                ($comparabilityKey, undef)
                        = $comparabilityGraph->connected_component_by_index($graphComponent);
            }

            # Copy the existing declaration
            $rhNewPP->{$expr} = dclone($rhPunto->{$expr});

            if (!exists($hComparabilityIndices{$comparabilityKey})) {
                my $comparabilityIdx = $contadorId++;
                while ($expr =~ /\[\]/g) {
                    my $subscriptComparabilityIdx
                            = $arrayIndicesAreComparable
                                    ? C_DUMMYHASHCODE_COMP() + 1
                                            : $contadorId++;
                    $comparabilityIdx .= "[" . $subscriptComparabilityIdx . "]";
                }
                $rhNewPP->{$expr}->{C_COMP()} = $hComparabilityIndices{$comparabilityKey} = $comparabilityIdx;
            }
            else {
                $rhNewPP->{$expr}->{C_COMP()} = $hComparabilityIndices{$comparabilityKey};
            }
        }

        if (scalar keys(%$rhNewPP) > 0) {
            $rhNuevasDecls->{$punto} = $rhNewPP;
        }
    }

    return $rhNuevasDecls;
}

=head2 updateComparabilityGraphs(rhVarsByPP, rhCompInfo, rhTraces, processName)

=over 2

=item Usage:

Public function.

=item Arguments:

=over 2

=item rhVarsByPP: reference to a hash from program point names to
references to hashes from the variables to their type information.

=item rhCompInfo: reference to a hash from program point names to
Graph objects. The connected components in each graph represent the
expressions that are comparable inside that program point.

=item rhTraces: reference to a hash from program point names to their
execution traces.

=item processName: string with the name of the process.

=back

=item Description: updates rhCompInfo using all the execution traces
in rhTraces.

=back

=cut

sub updateComparabilityGraphs
{
    my ($rhVarsByPP, $rhCompInfo, $rhTraces, $processName) = @_;
    while (my ($pp, $rvTrace) = each(%$rhTraces))
    {
        updateComparabilityGraphsForPP($pp, $rvTrace, $processName, $rhVarsByPP, $rhCompInfo);
    }
}

sub updateComparabilityGraphsForPP
{
    my ($pp, $rvTrace, $processName, $rhVarsByPP, $rhCompInfo) = @_;

    my @exprs = map { /( (?-x:(?:INICIO|FIN)(?= AMBITO))
                       | (?-x:(?<=Ruta accedida: ).*(?= \[\]))
                       | (?-x:(?<=Completed normally assignment to ')[^']*(?=')))/x; } @$rvTrace;

    unless (defined($rhCompInfo->{$pp})) {
        $rhCompInfo->{$pp} = Graph::Undirected->new(unionfind => 1);
    }

    my @pilaAmbitos = ();
    my $comparabilityGraph = $rhCompInfo->{$pp};
    foreach my $expr (@exprs) {
        # Además de convertir al formato de Daikon, retiraremos los
        # índices numéricos (se supone que todos los elementos del
        # vector tienen el mismo tipo abstracto de datos)
        $expr =~ tr#/$#.#d;
        $expr =~ s#\.(?:[^\.:/]*?):#.#g;
        $expr =~ s/\[[0-9]+\]/\[\]/g;

        if ($expr eq "INICIO") {
            # Abrimos un nuevo ámbito, sin aún representante
            push @pilaAmbitos, undef;
        }
        elsif ($expr eq "FIN") {
            # Cerramos un ámbito
            die "Ámbitos no equilibrados"
                if scalar @pilaAmbitos == 0;
            pop @pilaAmbitos;
        }
        elsif (scalar @pilaAmbitos > 0 && exists $rhVarsByPP->{$pp}->{$expr}) {
            # Si es la primera expresion de este ámbito, se convertirá
            # en su representante por el momento: toda expresión que
            # vaya a continuación suya en el mismo ámbito será
            # comparable con ella
            if (!defined($pilaAmbitos[-1])) {
                $comparabilityGraph->add_vertex($expr);
                $pilaAmbitos[-1] = $expr;
            }
            elsif ($expr ne $pilaAmbitos[-1]) {
                $comparabilityGraph->add_edge($pilaAmbitos[-1], $expr);
            } # según estado del ámbito
        }
        else {
            # Asignación de tipo complejo (como la que usa un
            # <literal> o copia de árboles XML completos)
            #
            # Normalmente se hacen asignaciones <literal>es a partes completas de un mensaje,
            # por lo que habrá que añadir al grafo de comparabilidad todas las partes de dicho
            # mensaje o elemento. Pasa lo mismo cuando se copian elementos completos.
            #
            # Además, habrá que hacer que cada nodo hoja sea
            # comparable con el nodo hoja del elemento origen
            foreach my $subexpr (keys %{$rhVarsByPP->{$pp}})
            {
                # No se agregan de esta forma automáticamente los atributos con valores fijos
                next if index($rhVarsByPP->{$pp}->{$subexpr}->{C_TJAVA()},"=") != -1;

                if ($subexpr =~ /^\Q${expr}\E((?:\[[^\]*]\])?(?:\..*)?)$/) {
                    my $sufijo = $1;

                    $comparabilityGraph->add_vertex($subexpr);
                    if (defined($pilaAmbitos[-1])
                        && exists $rhVarsByPP->{$pp}->{$pilaAmbitos[-1] . $sufijo})
                    {
                        $comparabilityGraph->add_edge($subexpr,
                                                      $pilaAmbitos[-1] . $sufijo);
                    }
                }
            }

            $pilaAmbitos[-1] = $expr if scalar @pilaAmbitos > 0;
        }

    } # para cada expresión

}

sub _loadCGraphs {
    my $rhInfoComp = {};

    foreach my $pathToCGraph (@_) {
        print STDERR "Loading saved comparability graphs from $pathToCGraph\n";

        my $rhLoadedInfoComp = retrieve($pathToCGraph);
        while (my ($pp, $loadedGraph) = each(%$rhLoadedInfoComp)) {
            if (!defined $rhInfoComp->{$pp}) {
                $rhInfoComp->{$pp} = $loadedGraph;
            }
            else {
                my $g = $rhInfoComp->{$pp};
                foreach my $rvComponent ($loadedGraph->connected_components()) {
                    my ($first, @rest) = @$rvComponent;
                    $g->add_vertex($first);
                    foreach my $other (@rest) {
                        $g->add_edge($first, $other);
                    }
                }
            }
        }
    }

    return $rhInfoComp;
}

1;
